Subject: Re: [PATCH] rebase -i: use same commit's message and date with f -C

From: Junio C Hamano <[email-masked]>
Date: Tue, 23 Sep 2025 14:38:53 -0700

"Mathias Rav" <[email-masked]> writes:

> In `git rebase -i` with the fixup command, the -C flag controls whether
> the commit message is taken from the previous or current commit,
> but currently the author name, email and date are always taken from the
> previous commit.

As the name of the command says, you are fixing up the previous one,
so I do not find it a problem if the credit for writing the
resulting combined commit stays with the author of the previous one.
The authorship information both covers the contents recorded in the
commit's tree, as well as the commit message.

Granted, many commits of this project that is a one-liner change
often have 50 lines of explanation in the commit log message, but
still I think it is sensible to give more authorship credit to the
author of the contents the tree of the final commit than to the
author of the log message of the final commit.

> Change the behavior so that fixup with -C takes both message and author
> from the current commit, instead of taking the author from the previous.

I am somewhat negative to this change.  I am perfectly fine to have
a separate "I may have started from that previous one, but that was
so broken that I essentially dismantled the original and replaced
with the new one.  It is better to attribute the credit to whoever
did this last one that is replacing" command.  But the "fixup"
command people have been familiar with would be different, I would
think.